# System diagram and requirements

## system diagram
![sm](assets/03_requirements-and-nice-to-haves-20240328074833721.jpg)  
The system consists of a main controller, connected to multiple sensor module boards and connected to a display and menu navigation control.  
The power supply unit is connected to the main controller. From there power is distributed to the other parts of the system.  
The main controller has a USB port that connects to a computer. In normal operation, MIDI data is send over this USB port to the computer.  
The system can have multiple sensor board modules and every sensor board module can have multiple sensors.  
Every sensor has a sensor to sense hit velocity and a multicolor LED for user feedback.  

## requirements
- midi output
- Wicki-Hayden Key  layout
- At least 2 octaves
- RGB LED backlit pads
- Velocity sensitive
- power input
- USB communication

## nice to haves
- sustain pedal
- 76 keys (= 4 octaves, which is a Marimba standard)
- sound synthesis onboard

## maybe sometime
- multifunctional pedal that can be assigned an action
- More key layouts, e.g. piano layout, in-scale layout, chromatic layout
- stand
- USB host to connect other midi controllers to the marimbatron (controlling it + MIDI passthrough)

## Fabacademy requirements
Your project should incorporate 2D and 3D design, additive and subtractive fabrication processes, electronics design and production, embedded microcontroller interfacing and programming, system integration and packaging.

Final documentation should answer:  
- What does it do?
- Who's done what beforehand?
- What did you design?
- What materials and components were used?
- Where did they come from?
- How much did they cost?
- What parts and systems were made?
- What processes were used?
- What questions were answered?
- What worked? What didn't?
- How was it evaluated?
- What are the implications?

Prepare a summary slide and a one minute video showing its conception, construction, and operation.

## Documentation checklist
- [ ] Made your **slide**> 1920 x 1080 pixels with your name, project name, Fab Lab name, a photo/render/sketch of your project, a brief description of what your project is/does
- [ ] Made a ~1 minute (10MB/1080p) **video** of you explaining your project
- [ ] Made a separate **Final Project page** that briefly summarises your project
- [ ] Included the BOM (Bill of Materials) for your project
- [ ] Linked from this page to any weeks that you worked on your final project
- [ ] Documented how you implemented system integration in your final project
- [ ] Linked to your presentation.png and presentation.mp4; make sure they are located to the root of your website
- [ ] Included all of your original design files in the archive (2D & 3D, board files & code). No external hosting of final project files - discuss file sizes with your instructor
- [ ] Included the license you chose
- [ ] Acknowledged work done by others