# Introduction
The Marimbatron is a fully featured digital marimba made during [Fabacademy](https://fabacademy.org/) 2024 by Leo Kuipers. Fabacademy is a gobal multi-disciplinary five-month program supported by local fablabs to gain hands-on experience with digital making. If you're interested, please check out Fablab Waag Amsterdam at [https://fablab.waag.org/](https://fablab.waag.org/).

The Marimbatron is a MIDI-based USB musical instrument that you play with drumsticks and/or mallets. It supports an isomorphic key layout which maintains consistent musical intervals between keys, allowing for the same shapes to be used for chords and scales regardless of the root note. This layout is called "[Wicki-Hayden](https://en.wikipedia.org/wiki/Wicki-Hayden_note_layout)" and originates from Bandoneons and Concertinas.  
I'm a drummer myself. And I wanted to make this instrument because I tried hard to learn to play the piano, but I never really got the hang of it. As a traditional marimba has a piano key layout, I'm not really capable of playing the marimba. I wanted to play chord and harmonies though and figured that this could be the way to do that. It does however also support the traditional piano key layout.  
The Marimbatron is designed to be modular. Every octave is a fully self-contained module with 19 pressure sensitive pads and a SAMD21J18 48Mhz ARM® Cortex®-M0+ microcontroller.  
All octave modules are connected using I2C to a SAMD21E18 48Mhz ARM® Cortex®-M0+ main microcontroller.
In total the Marimbatron consists of 76 fab-made pressure sensors with high-speed readout (200 us to read 19 sensors, 12-bit ADC). This will make it output MIDI data in less than 10ms.  

![../presentation.png](../presentation-small.jpg)  

<video controls> <source src="https://fabacademy.org/2024/labs/waag/students/leo-kuipers/presentation.mp4" type="video/mp4"> </video>

All of the Marimbatron is self-made in our [Fablab](https://www.fablabenschede.nl):

- the body (lasercut plywood)
- the pressure sensors (casted polyurethane with graphite-sprayed PET sheet and a flexible PCB that can be made using a vinylcutter)
- the top sheet (recycled PLA from failed 3D prints which are shredded and heatpressed into sheets and made into a big sheet using friction welding, next lasercut and bend using a heatgun)
- the electronics (a combination of SAMD21E18 main microcontroller and 4 SAMD21J18 microcontrollers for high-speed ADC readout of the sensors, all microcontrollers interconnected using I2C)
- the buttons (3D printed PETG with UV printed symbols)
- The programming of the firmware

See [my Final Project documentation](../../final-project/00_marimbatron.md) for more information.  

The Marimbatron was reviewed by [Professor Neil Gershenfeld](https://en.wikipedia.org/wiki/Neil_Gershenfeld), Director of [Center of Bits and Atoms](https://cba.mit.edu/about/index.html) at Massachusetts Institute of Technology (MIT).  
You can watch this review here:  
<video controls> <source src="https://fabacademy.org/2024/labs/waag/students/leo-kuipers/review.mp4" type="video/mp4"> </video>

The Marimatron was featured on:  

- [Hackaday.com](https://hackaday.com/2024/06/13/marimbatron-a-digital-marimba-prototyping-project/)
- [Hackster.io](https://www.hackster.io/news/hitting-all-the-right-notes-b8ee732ca450)


 [All source code and design files are available on gitlab](https://gitlab.fabcloud.org/academany/fabacademy/2024/labs/waag/students/leo-kuipers/-/tree/main/files/final-project/!Final-design-files?ref_type=heads) for non-commercial, non-profit purpose.  

```
** This work may be reproduced, modified, distributed, performed, and
** displayed for any non-commercial, non-profit purpose, but must acknowledge
** the developer and the Marimbatron project.
** Copyright is retained and must be preserved. The work is
** provided as is; no warranty is provided, and users accept all liability.
**
** Copyright 2024 Leo Kuipers.
```
