# welcome
Welcome to my Fabacademy 2024 documentation site.  
From here you can go to the documentation of all fabacademy assignment weeks and my final project. Here we go.

## useful links first
My own page: [https://fabacademy.org/2024/labs/waag/students/leo-kuipers/](https://fabacademy.org/2024/labs/waag/students/leo-kuipers/)  
My git: [https://gitlab.fabcloud.org/academany/fabacademy/2024/labs/waag/students/leo-kuipers](https://gitlab.fabcloud.org/academany/fabacademy/2024/labs/waag/students/leo-kuipers)  

All fabacademy 2024 students (200!): [https://fabacademy.org/2024/people.html](https://fabacademy.org/2024/people.html)  
All fabacademy nodes 2024 (48): [https://fabacademy.org/2024/labs.html](https://fabacademy.org/2024/labs.html)  
All fabacademy content: [fabacademy.org/2024/](https://fabacademy.org/2024/)  
Public fablab git: [https://gitlab.fabcloud.org/pub](https://gitlab.fabcloud.org/pub)    
Nueval 2024: [https://fabacademy.org/2024/nueval/](https://fabacademy.org/2024/nueval/)  
Global open time: [https://zoom.us/j/9699009392](https://zoom.us/j/9699009392)  
Expert Network Map [pub.fabcloud.io/project/expert-network-map/](https://pub.fabcloud.io/project/expert-network-map/)  

## whoami
![](assets/2024-01-27-whoami.jpg)  
My name is [Leo Kuipers](https://www.linkedin.com/in/leokuipers/) (1979) and together with my wife and kids, I live in the east of the Netherlands, near the German border.  I'd describe myself as an enthusiastic technological creative. A generalist (knowing a little bit about a lot) that wants to know and wants to create.  
  
I'm educated in Media Engineering, which holds the middle between Multimedia Design, Electronic Engineering and Computer Sciences. Especially the boundary between hardware, software and user experience is what interests me the most. I worked in the audiovisual industry as project manager, product manager, innovation manager and R&D manager for over 15 years.   

Then came covid, paralyzing this industry and forcing me to change careers. This turned out great! Since 2021 I work at the [Fablab in Enschede](https://www.fablabenschede.nl). This Fablab is part of the Saxion University of Applied Science. I didn't know anything about 3D printing, CNC & laser cutting and all the other beautiful stuff that happens at Fablabs. I'm so excited that I got the opportunity to be part of Fabacademy 2024!
In my free time I'm a musician and I love music technology. I spend lots of time in my little home-studio on my customized e-drums and having fun on all my other e-instruments. So I think the subject of quite a few of my weekly assignments will be about musical instruments. I look forward to the big rabbit hole that lies ahead!

![](assets/rabbithole.jpg)  
*Copilot AI: A cross-sectional side view of a rabbit hole in the style of a Japanese manga. Alice is standing on top of a hill in the grass looking down into a giant rabbit hole, excitedly wondering if she would dare to jump.*

## learning goals
- Become proficient in creating 3D files (using fusion 360). This is a big one for me. I know my way around computers. I know my way in 2D. But I dived into 3D only when I started working at the Fablab. I'm by no means proficient and would like to make it a second nature. 
- I think I like molding and casting. Let’s find out. 
- kiCAD. I've already designed PCBs in Fusion360 and Altium. Would be great to learn an open source alternative. 
- Create flexible PCBs. I know how to create standard FR4 PCBs but never made a flexible one.
- Get more knowledgeable about when to choose which microcontroller. Just because there is so much to choose from. 
- Rust. I know quite a few programming languages (C, Python, PHP, JS). I was told Rust is the next big thing. Let's find out. 
- More CNC. I know too little of it and am still a bit intimidated by the big CNC machines...

## the others
### Amsterdam Waag team
I'm not doing Fabacademy alone. Fortunately! Here's the 2024 team:  
  
Joe Wallace - Amsterdam/Birmingham - technician  
Joany Beer - Delft - UX/UI designer,  industrial design  
Edwin Dertien - Oldenzaal - University of Twente (robotics, creative technology), Kunst en techniek werk  
Vera Schepers - Arnhem -  fablab HAN - art & design  
  
Henk  Buursen - Amsterdam - Lead fablab Waag  
Michelle Vossen - Amsterdam - Maker & Educator fablab Waag
Bas Pijls - Amsterdam - teacher @ HvA: computer programming  
Erwin Kooij - Deventer - Dutch Railways - Electronics  
Saco Heijboer - Amsterdam - projectmanager innovation and product development self employed - mechanical engineering

### regional fablab team
Fablabs who join our regional meeting:
#### [Amsterdam, Netherlands](https://fabacademy.org/2024/labs/waag/)
- Instructor: [Henk Buursen](https://fabacademy.org/2018/labs/fablabamsterdam/students/henk-buursen/)
- Instructor: [Michelle Vossen](https://fabacademy.org/2023/labs/waag/students/michelle-vossen/)
- [Edwin Dertien](https://fabacademy.org/2024/labs/waag/students/edwin-dertien/)
- [Joany Beer](https://fabacademy.org/2022/labs/waag/students/joany-beer/)
- [Joe Wallace](https://fabacademy.org/2024/labs/waag/students/joe-wallace/)
- [Leo Kuipers](https://fabacademy.org/2024/labs/waag/students/leo-kuipers/)
- [Vera Schepers](https://fabacademy.org/2024/labs/waag/students/vera-schepers/)

#### [AgriLab (Beauvais, France)](https://fabacademy.org/2024/labs/agrilab/)
- Instructor: Luc Hanneuse
- [Alexis Lepage](https://fabacademy.org/2024/labs/agrilab/students/alexis-lepage/)
- [Jean-Côme Picot](https://fabacademy.org/2024/labs/agrilab/students/jeancome-picot/)
- [Pol-Emile Briot](https://fabacademy.org/2024/labs/agrilab/students/polemile-briot/)

#### [fab-c (Charleroi, Belgium)](https://fabacademy.org/2024/labs/fabc/)
- Instructor: Sylvain Denis
- [Charlotte Vandenbulcke](https://fabacademy.org/2024/labs/fabc/students/charlotte-vandenbulcke/)
- [Elodie Moulin](https://fabacademy.org/2024/labs/fabc/students/elodie-moulin/)

#### [ULB (Ixelles, Belgium)](https://fabacademy.org/2024/labs/ulb/)
- Instructor: Nicolas De Coster
- [Alex Rivera](https://fabacademy.org/2024/labs/ulb/students/alex-rivera/)
- [Bogdan Popovici](https://fabacademy.org/2024/labs/ulb/students/bogdan-popovici/)
- [Charlotte Deroubaix](https://fabacademy.org/2024/labs/ulb/students/charlotte-deroubaix/)
- [Luis Abel Rodríguez De Torner](https://fabacademy.org/2024/labs/ulb/students/luisabel-rodriguez/)
- [Siméon Michel](https://fabacademy.org/2024/labs/ulb/students/simeon-michel/)
- [Teo Serra](https://fabacademy.org/2024/labs/ulb/students/teo-serra/)

#### [Fab Lab Armenia Dilijan (Dilijan, Armenia)](https://fabacademy.org/2024/labs/dilijan/)
- [Areg Khalatyan](https://fabacademy.org/2024/labs/dilijan/students/areg-khalatyan/)
- [Elen Grigoryan](https://fabacademy.org/2024/labs/dilijan/students/elen-grigoryan/)
- [Maria Hovhannisyan](https://fabacademy.org/2024/labs/dilijan/students/maria-hovhannisyan/)
- [Rita Tumasyan Rita](https://fabacademy.org/2024/labs/dilijan/students/rita-tumasyan/)
- [Vachagan Azatyan](https://fabacademy.org/2024/labs/dilijan/students/vachagan-azatyan/)

#### [Kamp-Lintfort (Kamp-Lintfort, Germany)](https://fabacademy.org/2024/labs/kamplintfort/)
- [Bianca Guimarães](https://fabacademy.org/2024/labs/kamplintfort/students/bianca-guimaraes/)
- [Ece Öner](https://fabacademy.org/2024/labs/kamplintfort/students/ece-oner/)
- [Frauke Waßmuth](https://fabacademy.org/2024/labs/kamplintfort/students/frauke-wassmuth/)
- [Helmut-Uwe Terton](https://fabacademy.org/2021/labs/kamplintfort/students/helmutuwe-terton/)
- [Sophia Döring](https://fabacademy.org/2024/labs/kamplintfort/students/sophia-doring/)


For all weekly assignments my work is provided as Creative Commons Attribution Non Commercial.  
For my final project: Copyright 2024 Leo Kuipers  