# lecture notes

## global review previous week
Rendering a fusion model in Blender is done by [Bernardo Lamuno out of fablab Puebla](https://fabacademy.org/2024/labs/puebla/students/bernardo-lamuno/assignments/week02.html)

## this weeks lecture
### Vinyl cutting
Fablab instructor Danielle Ingrasia made [fabulaser](http://fabulaser.net/) which is an open source industrial grade laser.  
There are extensions in various CAD tools to aid in designing for cutting. E.g. making fingerjoints.  
victoria shen made flexible PCBs using vinyl cutter: [link here](https://fab.cba.mit.edu/classes/863.18/Harvard/people/victoria/week_04.html)  
Honghao Deng [did the same here](https://fab.cba.mit.edu/classes/863.17/Harvard/people/HonghaoDeng/project-9/project-9.html)
In [https://inventory.fabcloud.io/](https://inventory.fabcloud.io/) there's a link to standard materials for vinyl cutting e.g. copper tape, backing, etc.  
Weeding is removing the material you don't want. Cutting with too much force: threaded mess. Too less force: you don't cut through. When weeding: don't pull up, but sheer it away.  
Recommendation for vinyl cutting instead of using Roland Truevis: Silhouette Cameo 4 (couple 100 dollars) -> perfect and high detail. 

### laser cutting
focus on press-fit construction.  
Lot's of different types of joints:  
![](assets/03_lecture-notes-20240207171512776.jpg)  

Chamfer slot is much better than press-fit. Especially with cardboard. They help align. And it compresses the material which helps the fit. Window to get a good pressfit: few 1/1000 inch.  
Snap-fit: there's a bump. That compresses the whole material.  
Flexure: works like locking mechanism of a backpack.  
Pinned joined: use a pin to fix it.  
Be aware: Sharp corners create stress concentration in the material, so will fail. Create chamfers:  
![sm](assets/03_lecture-notes-20240207172519324.jpg)


Beginner lasercutting = cutting on the line.  
Advanced lasercutting = taking into account Kerf: offsetting by 1/2 of the width of the laser beam (beam kerf). Requires an offset.  

Flexure: don't cut all the way through. Outside of material stays nice:  
![sm](assets/03_lecture-notes-20240207172709379.jpg)

Mechanisms: use flat material and cut shapes so you can create a part that can have motion without bolts, bearings, etc. Downside: you have only 1/3 of movement compared to total size of the mechanism:  
![sm](assets/03_lecture-notes-20240207173045897.jpg)

Laser beam should be focussed on the beam waist:  
![sm](assets/03_lecture-notes-20240207173441632.jpg)  
Usually you want this. Called in-focus. But sometimes you want it intentionally out of focus.  
![sm](assets/03_lecture-notes-20240207173912494.jpg)


CO2 is most common type of laser. Wavelength: far into infrared. You can't see the beam. 10.6 micron. Works great on wood, acrylics, cardboard.  No metal. 
Fiber wavelength 1-2 micron. Good for marking metal. With more power (1000 of watts): cutting metal. 10ths of watts required to remove copper from PCB.

depending of type material a laser will burn, melt, evaporate or eblatorate material.  

Key part of lasercutting is airflow. Air assist.  
When done right, you don't see any smoke.  
Don't open up laser cutter right after cutting: the material has outgassing! Especially acrylic. Still hazardous fumes will exit the material. Leave the lid closed for a couple of minutes!  

Good cardboard can be bowed. It will not "break/bend".  

[Acrylic glueing](https://www.mcmaster.com/#standard-acrylic-glue/=1bgkitd)    
Use laser to [bend acrylic](https://hcie.csail.mit.edu/research/laserorigami/laserorigami.html): offset laser to get heat into it.  

PVC: use flame. If you see color: it's PVC.  
Polycarbonate: don't use it. You need a powerful laser. Will make smoke and a mess.  
Metals: in CO2 use CerMark. No other way. It will reflect laser back into the machine.  
Too much energy in one place: You will burn or melt. Use multiple pass.  

## AI recitation
### LLMs
looping LLMs in a feedback-loop way: autogpt: [agentGPT](https://github.com/Significant-Gravitas/Auto-GPT)  
Langchain can do this too (full control).  
[Mistral too](https://huggingface.co/mistralai/Mixtral-8x7B-Instruct-v0.1).  

### CAD/CAM

![sm](assets/03_lecture-notes-20240215073932652.jpg)  
LLM goes from text to code and then manually from code to CAD/CAM as a separate process.  
DSL: Domain Specific Language.  
Especially going from text to openSCAD code works pretty good. Tip: Go from small to large: i.e. first ask for code for a box then ask to use that code to create a table.  

### 3D modeling
For 3D modeling: [threestudio](https://gitgub.com/threestudio-project/threestudio) and [lumaAI](https://lumalabs.ai/genie). But model quality is not very good.  
a High quality version that spun off of MIT HTMAA is [depthfusion](https://github.com/valleballe/depthfusion).  

### Electronic design
Use LLM to ask question regarding electronic component datasheets. For example: what is the pinout, what is max temperature, write code, etc.  
Board designerGPT: works for simple designs.  
Watch out for halucination! It will have it wrong quite often!  
### Fabacademy AI Lab
launched at instructiors bootcamp in Leon 2024.  
Mattermost channel: FabAcademy AI Lab. Open to students as well. Bi-weekly meetings.  
Custom GPTs -> powered by OpenAI-4. create custom behavior e.g. using reference documents.  
COTS/NOTS approach: Commercial Off The Shelf: OpenAI, Google Gemini, Azure AI Studio, Anthropic Claude 2.  
Open Weights: Meta Llama-2, Yi 01, Alibaba Qwen, DeepSeeker Coder.  
OLMo - Allen AI Institute, Flor (Barcelona super computing center) -> real open source model. Has Weights, Data and code as open license.  

AI Helper Tools: 
open mode = Whisper Model -> Speech-to-text. Transcribe audio files and translate from any language to English.  
[Whisper Writer](https://github.com/savbell/whisper-writer) (runs locally).  

Best local LLM apps (open weights):  

- Best multiplatform: GPT4ALL (enables you to consult your documents)
- Best UI: LM Studio
- Best for light customization: Ollama + Ollama Web UI
- Best for LLM Geeks (try out any LLM you can download): Text Generation Web UI

### Zoom AI Companion
Zoom uses Federated AI: multiple models with a scorer that defines if a model produces good results. If not a more costly model is going to give it a try.  
![sm](assets/03_lecture-notes-20240215085149942.jpg)  

### Other notes
Lots of energy is consumed by cloud LLMs. There's lots of work to be done to simplify the LLMs and to make them run on embedded controllers. This will decrease power consumption. Seeed studio is active in this field.  
Vocational skills = the practical skills specific to a career, trade or job role.  
Fab futures are the vocational skills for tomorrow. "21st century vocational skills". It's a class that will hopefully run in fall 2024. Consisting of:  

- Synthetic biology
- Sustainability
- Precision Agriculture
- Video Game Development
- Computer Graphics
- Nanotechnology
- Microelectronics
- Robotics
- Cyber Security
- Big Data
- Artificial Intelligence

Fab Futures are 1 month units for each subject. It never stops and never ends. Continuous 1 months cycles. Units that will get the most traction will spin off in deeper dive recitations.  
All digital content will be freely available. Cost is for realtime participations, accreditations, evaluations, etc. 

Previously the fablab was defined by its tools. More and more it will be defined by its community and culture.  


