# lecture notes

## global review previous week
[preciousplastic.com](https://www.preciousplastic.com) is an organisation/website that explains how to recycle plastic. 
Arduino libraries are very slow. E.g. digitalWrite(). Some arduino cores have digitalWriteFast(). This is 6 times faster. So don't use Arduino library if you care about speed.  
PWM is very powerful. However, Arduinos AnalogWrite() hides a lot of its power. So very limiting way of using PWM.  
learn how to use an rp2040 there's a class in Cornell about embedded development on the rp2040 and they go into a lot more detail. [Their lectures are on youtube](https://www.youtube.com/playlist?list=PLDqMkB5cbBA5oDg8VXM110GKc-CmvUqEZ).    

## this weeks lecture
This week is about fixturing, speeds, feeds and safety.

lots of examples of large format machining. For example [ifurniture](http://fablabifurniture.org/).  
Shaper is  a computer controlled mill that you can use to bring a machine to the stock instead of the other way round.  
Maslow is like a drawing robot, but it doesn't draw :D  
Differences in CNC machines is mostly about being larger, more robust, high volume, etc.  
Open designs of machines that can be made in a fablab is [machines.fabcloud.io](https://machines.fabcloud.io/).  

### stock material
[Chairigami](https://www.chairigami.com/) is furniture out of cardboard. Cardboard can be made suprisingly robust.  
Rigid foam insulation can be machined easily and is mainly used to make large molds.  
4 x 8 inch sheets are standard measurements for a sheet of wood.  
Veneer plywood is what we would call multiplex. It consists of laminated layers of wood. It's fairly expensive.  
MDF is medium density fiberwood are short wood fibers in a glue binder. Compared to veneer plywood it is cheaper. It machines easily because it is homogeneous so you'll get a very smooth surface. But it's also heavy with very poor mechanical properties (the fibers don't really carry the load so you'll just shear the binder). Some of the binders are hazardous because of the gasses they outgas.  
Valchromat is through-core colored MDF.  
MDO (medium density overlay) is a plywood core with MDF on top for a smooth surface.
OSB is little pieces of leftover wood, glued together. Cheapest of them all. It has a rough surface. But you can machine/sand/finish it and make is smooth.  
HDPE (High-density polyethylene) is a plastic that machines easily. It has a high strength-to-density ratio.   
Lexan and polycarbonate is really touch plastic. Used as bulletproof / shatterproof glass. Can be machined but hard to lasercut.  
Garolyte is a non-hazardous composite. It's a high-pressure fiberglass laminate, created by stacking multiple layers of glass cloth soaked in epoxy resin and then compressed. It machines easily and has good structural properties. It is used for example as subtrate for FR1 circuit boards.  
Hylite is an aluminium layer on top of a polymer plastic. Outside looks like aluminium. Polymer core can flex, bend, etc.  

### tooling
there are lots of tools. [this list is standard for a fablab](https://inventory.fabcloud.io/?purpose=Computer-Controlled%20Machining).  
A drill can only come down and make holes.  
A flat-end mill is designed to go down but especially to the side. So can plunge but will cut better to the side.   
router bits are not designed to go down.  
flutes on an end mill are the spirals. 2 flute can go faster, but surface is rougher. 4 flute has less space for chips and so cannot go that fast, but smoother finish.  
The coating of an end-mill make it last much longer. You want that.  
Center cutting vs up-down cutting:  
flute with room on the bottom -> room for chips, but cannot plunge. 
flutes meet on the bottom -> can plunge, but less capable of removing chips.  
depending on the circular rotation of the flutes either chip go up or will be pushed down. Pushing down will give nicer top finish, but chips can't go anywhere. So typically you can do down-cut on top surface and then up-cut for the rest of the movement. There are even mills that can do both (center cut?).  
An upcut will pull your stock up. So make sure to clamp it down!  
flat bottom end mill (bottom is flat -> gives steps in Z-direction) / ball end mill (bottom is curved -> gives nice result especially for 3D milling).  

### speeds and feeds
The [machinery handbook](http://new.industrialpress.com/machineryhandbook) is the bible for CNC. You should have it.  
It's all about how deep and how fast you cut -> how big are the chips?  
Going too fast will make screaming noise, tool will overheat and break.  
Going too slow is lots of waisted time and tool has to "bite" into the material, but might not be able to do so.  
In each succeeding pass the size of the chip is the feedrate / (rpm x number of flute).  
Cut depth rule of thumb: go down by roughly the diameter of the tool.  
Step over rule of thumb: 1/2 of the diameter of the tool.  
For each material, machine and tool you should define the speeds and feeds. [This is a calculator](https://zero-divide.net/fswizard).  

### abrasive machining
End mills are made by grinding. You can't machine glass, but you can grind it. For example with a tool without any flutes in an abrasive slurry. But the abrasive needs to be contained. Otherwise it'll ruin your machine.  

### Fixturing
Fixturing is a big part of large format machining.  
You can use a vise. Expensive ones are precision perpendicular and precisely made flat.  
Screws are suprisingly handy. It's a common way to do it. There are even special nails for machining because they can be machined.  
Vacuum beds are great because they hold down everywhere. Typically used in large volume machining.  

Every machine will have a sacrificial layer that you machine into. They should be changed periodically. You will then machine the whole bed so it's completely flat.  
Squaring: if CNC machines are bolted together, eventually the bed might not be square anymore or the Z-axis is slightly tilted. So everything needs to be perpendicularly. Every few years, you need to make sure it's square again. That's called squaring.  

To steam bend you can use wacky wood, which is easier to bend because of the alignement of the layers.  

### joints
Japanese joints are beautiful. See [thingiverse](https://www.thingiverse.com/thing:169723).
According to Rico: Looks like those joints were developed by Kenji Kanasaki & Hiroya Tanaka (co-founder of Fablab Kamakura) as a research project at Keio University. [Here is the link to the abstract of the paper](https://keio.elsevierpure.com/en/publications/traditional-wood-joint-system-in-digital-fabrication). The actual paper [in pdf is here](https://papers.cumincad.org/data/works/att/ecaade2013_247.content.pdf).  
Another one: [50 digital joints](https://www.fablabifurniture.org/50-digital-joints).   

Very interesting is tsugite (Japanese word of joinery), a researchpaper by Maria Larsson, Hironori Yoshida, Nobuyuki Umetani, and Takeo Igarashi. 2020. See [ma-la.com](http://ma-la.com/tsugite.html). Windows Software can be downloaded. [Github is here](https://github.com/marialarsson/tsugite).  Written in Python.  

Match the number of constrains to the number of degrees of freedom  

### toolpaths
Kerf is the material that has been removed. Offsetting is to account for the thickness of the tool.  
The tool is in a collet in a spindle in a gantry. That gives all kind of meandering. The actual diameter that it will cut is larger than the diameter of the actual tool. That difference is called runout and defines quality of the machine.  

![sm](assets/07_lecture-notes-20240306173531582.jpg)  
conventional is on the left (typically used for roughing). climbing is on the right (typically used for finishing).  
This week we'll do rough cuts. When creating molds you want to do finish cut as well.  

trochoidal will make chips of the same size and is more 

2D -> only X and Y at same Z. 
2.5D -> Z in steps.
3D -> continuous change in Z.  

T-bones/dogbones will make things fit. This is because 3-axis machining will have an inner corner constraint. It cannot cut sharp inner corners aligned with the milling bit. They will have rounded fillets:  
![sm](assets/07_lecture-notes-20240306182035702.jpg) ![sm](assets/07_lecture-notes-20240306182213163.jpg)  
There are 2 ways to solve this: Create deeper inner corners, or round outer corners.  
![sm](assets/07_lecture-notes-20240306182324020.jpg) ![sm](assets/07_lecture-notes-20240306182342211.jpg)  
T-bones is a way to solve this when two pieces will need to mate. you create deeper inner corners:   
![sm](assets/07_lecture-notes-20240306173959835.jpg)  

Onion skinning -> no tabs, but mill almost to the bottom but not entirely. Easily to cut away.  

### safety
Machining is the most hazardous of them all! The safety risks are real!  

Look, listen and smell! Use Personal Protective Equipment! Wear safety glasses, closed shoes, wear gloves! No floppy clothes, long loose hair, etc.  
Never ever reach into a powered tool!  
[MIT safety training](https://ehs.mit.edu/training/).  

