# 1. mechanical design, machine design
## Topic(s) of this week
- [mechanical design](http://academy.cba.mit.edu/classes/mechanical_design/index.html), [machine design](http://academy.cba.mit.edu/classes/machine_design/index.html) ([_video_](https://vimeo.com/812971623), _review_)
    - Work and communicate effectively as a team
    - Design, plan and build a machine
    - Analyse and solve technical problems
    - Recognise opportunities for improvements in the design


## Hero shots
![sm](assets/10_1_mechanical-design_machine-design-20240409222812027.jpg)

## Assignments
### Group assignment
- Mechanical Design (part 1 of 2)
    - [x] Design a [machine](http://machines.fabcloud.io/) that includes mechanism + actuation + automation + application
    - [x] Build the mechanical parts and operate it manually
    - [x] Document the group project
- Machine Design (part 2 of 2)
    - [x] Actuate and automate your machine
    - [x] Document the group project
### Individual assignment
- Mechanical Design (part 1 of 2)
    - [x] Document your individual contribution
- Machine Design (part 2 of 2)
    - [x] Document your individual contribution
- Midterm assignment
    - [x] post a system diagram for your project
    - [x] list the tasks to be completed
    - [x] make a schedule for doing them
    - [x] meet with your local instructor to review

## What I think I already know
These weeks are going to be fun. I look forward to working as a group. I'm quite confident that I have good building skills. At least I know how and when to start using gaffa, ducktape, hotglue....

## What I want to learn
I hope that I can do a lot of mechanical work. Gears, driving belts, etc. are not my strongest point yet.  

## SSTM planning

For these 2 weeks I don't really have a SSTM planning. I'm quite flexible and we'll have to see how we divide work and when we can work together.  

### Tasks

Have you answered these questions?

- [x] Documented the machine building process to the group page
- [x] Documented your individual contribution to this project on your own website
- [x] Linked to the group page from your individual page as well as from group page to your individual pages
- [x] Shown how your team planned, allocated tasks and executed the project (Group page)
- [x] Described problems and how the team solved them (Group page)
- [x] Listed possible improvements for this project (Group page)
- [x] Included your design files (Group page)
- [x] You need to present your machine globally and/or include an aprox. 1 min video (1920x1080 HTML5 MP4) + slide (1920x1080 PNG) (Group page)
- [x] Leave feedback in [Nueval](https://nueval.fabacademy.org/) that this weekly is ready for evaluation.

## WAAG session
Saco gave us a presentation, specifically on machines and mechanical design.  
A machine is a device that uses power to perform actions to achieve tasks. Human or animal power is not allowed :D  
A machine usually consists of:  

- Structural components (frame, panels, supports, ...)
- Mechanisms (moving parts, gears, linkage, ...)
- Actuators (steppers, motors, hydraulics, pneumatics, ...)
- Sensors (temperature, speed, displacement, flow, ...)
- Controllers (PLC, microcontroller, ...)

To design a machine, you usually use a structure to define it. For example:  

- FBS Functional Breakdown structure
    - What should the machine do, what functions are needed, which functions should be combined or separated
- PBS Product breakdown structure
    - what should the machine look like, how can it be build
- WBS Work breakdown structure
    - what tasks are needed to create the machine, relation, dividing work, plan time and resources

Stability and degrees of freedom is very important -> Maxwell criteria! Think about the way your construction is set up. Think about the degrees of freedom. Do not overcontrain (i.e. a table with 3 legs is stable, a table with 4 legs is always wobling).  
A deep dive in kinematic coupling: [https://practicalprecision.com/laying-out-a-kinematic-mount-using-maxwell-criterion](https://practicalprecision.com/laying-out-a-kinematic-mount-using-maxwell-criterion)  
For optimal stability arrange the bearing surfaces such that, if one surface is removed, the direction in which the part would then be free to move is (as close to) perpendicular to that surface.  

(In)accuracy is related to:  

- play/hysteresis
- stiffness of the material
- error chain & force loops
- shapes: perpendicularity, flatness, parallel, symmetry, ..
- position

Controlling movement can be defined:  

- By hardware (e.g. slotted path and pin that follows it)
- Linkage mechanisms (can become quite complex, but nice)
- Step sequence control (split movements in steps and use a step diagram to define the sequence of movement) -> finally this is controlled usin PID or microcontrollers

Strandbeests are fully designed according to linkage mechanisms and step sequence control.

## Group assignment
[The group assignment pages can be found here](https://fabacademy.org/2024/labs/waag/RUPEV/)


## What I  learned this week
### Successes, fails and fixes
Time flies when you're having fun. I really enjoyed these weeks and we made something I'm proud of. And we had lots of fun during the process.  
I really wanted to work on mechanics because that is one of my fabacademy learning goals. The 4-bar linkage system was great! I enjoyed simulating, building and trying. Too bad the wormwheel didn't work out, but swapping it to the bevel gears was a good way to solve it. Although that did mean that my fusion design of the fixture could fly out of the window. I had to redesign because I had quite a lot of constraints based on the wormwheel idea. Swapping it out with bevelgears that required the axis to be on different positions wasn't easy at all. So that was my moment of darkness that I had to go through I guess :-)  
The last monday at Waag we really worked hard as a group to get things done. And we did. I'm fortunately quite skilled at video editing so I have all tools set up to make something nice.   
I'm really proud of the end result!
