# 2. Group assignment start page
## Real urban pigeon-eye view (RUPEV)
Based on [this TED talk of Peter McIndoe: "Birds aren't Real? How a Conspiracy Takes Flight"](https://youtu.be/3VEkzweBJPM?si=PTtGObMB_0BLBpAe) we wonder how the world looks like from a pigeon point of view.  

## Functional overview
RUPEV is going to be a pigeon shaped robotic machine with a camera system. The goal is to record the environment so this footage can be used to create a documentary.  

Let's go!  
![](assets/group-page-20240328162636253.jpg)  

## Group assignment links
[back to the main group page](https://fabacademy.org/2024/labs/waag/RUPEV/)
[10_4_group-assignment-mechanical-movement](10_4_group-assignment-mechanical-movement.md)

## MOSCOW analysis
### Must have
- at least 2 working camera's. 1 HQ in pigeon head, 1 LQ on the robot car for navigation
- Sound recording microphone (high quality on-board)
- storage of high quality camera footage (on-board)
- live footage for navigation & control (wireless)
- Live audio return (mic)
- Mobility, should be able to move around (all directions) the surrounding square of WAAG
- mission control (physical remote control)
- size, shape and color of an actual pigeon
- natural pigeon movement (strutting head movement by moving the neck while keeping the head planar, leg walking movement)
### Should have
- camera on robot should also be HQ (3rd person footage), or additional HQ camera on robot
- Pigeon sounds (PPA: Public Pigeon Address)
- Cloaking any mechanical part
- Night vision
### could have
- Body half side transparent (see-through) so you can see the mechanics inside
- More degrees of freedom: rotation in the neck base, moving the neck sideways.
- computer software to preprogram movements
- Fake flying (lifting arm + flapping wings)
- pooping mechanism (internal labelwriter that can write messages and distribute them)
- AI characterization of its surroundings (things to eat, things to mate with, things to be scared of and rocks)
- Smoke (vaperizor like e-sigaret) 
- Eyes that light up
- Online camera feed, audio (including mic) and remote control (crowd control)

### won't have
- It won't actually fly
- it won't be autonomous

## Design ideation
Robot car acting as a puppeteer. Robot has a drive shaft connected to the pigeon. This drives the mechanical movement of legs and head. Camera in/on pigeon head (pigeon-view) and camera on robot (3rd person view) .  
![sm](assets/group-page-20240328115339120.jpg) ![sm](assets/group-page-20240328115347893.jpg)  
![sm](assets/group-page-20240328115358487.jpg) <video controls> <source src="../assets/group-page-design.mp4" type="video/mp4"> </video>  

## Schedule

| date               | Location                                                             | availability      |
| ------------------ | -------------------------------------------------------------------- | ----------------- |
| Thursday march 28  | Amsterdam WAAG                                                       | All               |
| Friday march 29    | Amsterdam WAAG, 10.00h                                               | All               |
| Saturday march 30  | Enschede/Oldenzaal Edwin, 10.00h                                     | All but Joe       |
| Sunday march 31    | Enschede/Oldenzaal Edwin, 10.00h                                     | All               |
| Monday april 1     | (easter)                                                             | None              |
| Tuesday april 2    | (individually if possible)                                           |                   |
| Wednesday april 3  | Enschede Saxion, 10.00h                                              | not Vera          |
| Thursday april 4   | Enschede Saxion, 10.00h                                              | not Edwin         |
| Friday april 5     | ?                                                                    |                   |
| Saturday april 6   | t.b.d. based on progress                                             | not Leo, not Vera |
| Sunday april 7     | t.b.d. based on progress                                             | not Leo           |
| Mondag april 8     | finalization, shooting footage,  Amsterdam WAAG                      | All               |
| Tuesday april 9    | Leo @ home: Video editing<br>All @ own place: Finalize documentation |                   |
| Wednesday april 10 | D-Day                                                                |                   |

## Functional Breakdown structure
### Pigeon
(Mechanical focus)

|     | task                                                                                 | interfacing with | Who      |
| --- | ------------------------------------------------------------------------------------ | ---------------- | -------- |
| MH  | Leg and strutting head/neck movement                                                 | robot car        | Leo, Joe |
| MH  | size, shape and color of an actual pigeon                                            |                  | Edwin    |
| SH  | 1 HQ camera in the pigeon head                                                       | RC system        | Edwin    |
| SH  | Pigeon sounds                                                                        | RC system        | Joe      |
| CH  | More degrees of freedom: rotation in the neck base, moving the neck sideways.        | RC system        |          |
| CH  | Fake flying (lifting arm + flapping wings)                                           |                  |          |
| CH  | pooping mechanism (internal labelwriter that can write messages and distribute them) | RC system        |          |
| CH  | Eyes that light up                                                                   | RC system        |          |

### Robot car
(mechatronics focus)

|     | task                                                                                                           |                                                           | who         |
| --- | -------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------- | ----------- |
| MH  | Mobility (create the robot car), should be able to move around (all directions) the surrounding square of WAAG |                                                           | Vera, Edwin |
|     |                                                                                                                | 1. fixed arm<br>2a. Servo arm?<br>2b. mecanum wheels?<br> |             |
| MH  | Mechanical/electronical link to the pigeon                                                                     |                                                           | Vera, Leo   |
| MH  | 1 LQ camera for navigation                                                                                     |                                                           | Edwin       |
| MH  | Power source inside robot (batteries)                                                                          |                                                           | Edwin, Leo  |
| SH  | LQ robot camera should also be HQ                                                                              |                                                           | Edwin       |
| SH  | Cloaking any mechanical part                                                                                   |                                                           | All         |
| SH  | Night vision                                                                                                   |                                                           | Vera        |
| CH  | Smoke (vaperizor like e-sigaret)                                                                               |                                                           |             |


### remote control, camera & audio system
(Electronics focus)

|     | Task                                                                                                           |                                                                                                                                                                                                | Who   |
| --- | -------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----- |
| MH  | at least 1 working HD camera                                                                                   | - Sound recording microphone (high quality on-board)<br>- storage of high quality camera footage (on-board)<br>- live footage for navigation & control (wireless)<br>- Live audio return (mic) | Edwin |
| MH  | mission control & networking (physical remote control)                                                         |                                                                                                                                                                                                | Edwin |
| SH  | control pigeon sound                                                                                           | DFRobot DFPlayer pro                                                                                                                                                                           | Joe   |
| CH  | computer software to preprogram movements                                                                      |                                                                                                                                                                                                |       |
| CH  | AI characterization of its surroundings (things to eat, things to mate with, things to be scared of and rocks) |                                                                                                                                                                                                |       |
| CH  | Online camera feed, audio (including mic) and remote control (crowd control)                                   |                                                                                                                                                                                                |       |
