# lecture notes

## this weeks lecture
System integration class is a new class. The goal is to integrate different fabrication processes in one design (specifically for final project).  
A great presentation on user experiences is [this presentation](https://academy.cba.mit.edu/classes/system_integration/Jan.pdf). The presentation itself is here on vimeo: [https://vimeo.com/254518604](https://vimeo.com/254518604) and here: [https://vimeo.com/545454447](https://vimeo.com/545454447).  
Another presentation: [https://www.youtube.com/watch?v=SsIZHReoaBk](https://www.youtube.com/watch?v=SsIZHReoaBk) -> Neil on "How to fail at (almost) anything -- stories about success coming from failure"  - "My superpower is failure"  
And this video: You need to fail well [https://youtube.com/shorts/BWxjFGnHsyw?si=mip2iOl50D9hXo0t](https://youtube.com/shorts/BWxjFGnHsyw?si=mip2iOl50D9hXo0t)

DFM = design for manufacturing. A key principle. So that means:

- use standard components
- use methods that create shapes that don't require lot of post processing
- try to use as minimal adhesives as possible, use fasteners but not to much! Snaps with self aligning features are even better (flexures)
- Minimize parts
- select the fastest process (e.g. compare it to amount of products that need to be made)

So design the design to be usable and producible.  

Create a bill of material directly from Kicad using this plugin: [https://github.com/openscopeproject/InteractiveHtmlBom](https://github.com/openscopeproject/InteractiveHtmlBom)  

Document how to produce and operate.  

Fuzzing: give random inputs to your system. See if you can make it go crazy. Many security vulnerabilities are found this way.  

The goal of good system integration is to prevent failure. In Neils lecture there's a whole list of possible failures, called common failure modes.  

More tips on system integration are in this link: [https://fablabisafjordur.github.io/system-integration-tips/](https://fablabisafjordur.github.io/system-integration-tips/).  

Interesting documentaries on Design by Gary Hustwit: [https://www.hustwit.com/](https://www.hustwit.com/) and Abstract: the art of design [https://www.netflix.com/pt-en/title/80057883](https://www.netflix.com/pt-en/title/80057883).  

Boeing Starliner is a example of classic linear development:  [https://www.cnbc.com/2023/07/26/boeing-has-lost-1point5-billion-developing-starliner-spacecraft-for-nasa.html](https://www.cnbc.com/2023/07/26/boeing-has-lost-1point5-billion-developing-starliner-spacecraft-for-nasa.html).  
SpaceX Starship is an example of spiral development (if you have the budget):  
[https://www.space.com/every-spacex-starship-explosion-lessons-learned](https://www.space.com/every-spacex-starship-explosion-lessons-learned)  

Assignment for this week: document how the final project is integrated. What are all the subsystems and systems and how are the integrated. A good example is [https://archive.fabacademy.org/archives/2016/fablabtorino/students/440/project/P02/B2/electronics.html](https://archive.fabacademy.org/archives/2016/fablabtorino/students/440/project/P02/B2/electronics.html)