# lecture notes

## this weeks lecture
Ready fire aim ([https://www.youtube.com/watch?v=SsIZHReoaBk](https://www.youtube.com/watch?v=SsIZHReoaBk)) -> almost any project in Centre of Bits and Atoms failed. But out of that came something better.  
So do something but don't aim very hard. Afterwards, check what you've done and how you can apply it.  
You need an environment that let you do things while you're not really know what you're doing. You might not even be able to know if you made something useful. Sometimes you need someone else to see that. Ecosystems help with that so you traffic, talk to people, etc.  

Intellectual property is very misundertood in fablabs. And there's a lot wrong with patents.  
Every country has a invention and trademark office. You patent an invention to protect it, so you can make money from it.  
There are 2 types of patents: utility patents (what something does), design patents (the way something works). Utility patents are stronger.  
the USPTO has a search page. If you want to know if something is patented in the US, use this tool: [https://ppubs.uspto.gov/pubwebapp/](https://ppubs.uspto.gov/pubwebapp/). Or use [patents.google.com](https://patents.google.com).   
Almost anything you can think of is patented by somebody else. If you've reinvented something that is already known then you can't patent it. But it's not that hard to innovate over an existing patent which you can then patent.  
Public Disclosure: you tell about it, anybody can learn from it. For example in a public video. But having it in a repo is not considered disclosure. You have to file for patent before you do public disclosure.  
Defensive Disclosure: disclose an invention so nobody can file it for patent.  
Provisional patent: you have an idea but it isn't fully worked out yet. You file it at a patent authority but it is not made public. You can register the idea (pretty easy to do and low cost) and if the idea doesn't mature, you don't continue filing it. But if you have the provisional in, you have still protected the idea.  
You'll have to be first to file! They don't ask who invented it, but who filed first.  
Full fulling: once you make the filing it becomes public. So no trade secrets. It has to be teaching: somebody skilled in the art will have to be able to follow it. You almost always will have to use a patent attorney to file it because it's an art to make the claims.  
Drawings in the patent applications matter more than the abstract or the other text. The claims matter the most. The claim is what you get protection on. You start with general claims and then refine it in in actual specifications. If the claim is too narrow the patent is not useful. But when too broad it will be rejected. The goal is to make it as broad as possible but not getting rejected.  

In theory anybody can file a patent but in practice you will always use an attorney.  
To be patentable it has to be:  
Novel: is it new?  
non-obvious: is it trivial?  
useful: it has to do something with utility  

Note: The patent examiner is not a scientist. They might not understand it or have too much to do. So they might accept something that defies the laws of nature. It's not hard to get a patent. But that doesn't mean that it is useful or meaningful.  
It'll take years to get a response from your filed patent. Almost always you'll get feedback that some of the claims are rejected so you need to refine that (restrictions).  

What is and isn't protected is a huge discussion. E.g. is an API patentable? Can you patent software?  

PCT: international cooperation system. There's no international patent. There's no international patent office. The PCT coordinates the examinations. If you get a patent in a country, and you separately file for a patent in another country, the PCT examination can be used, speeding up the application.  

The patent does not protect you itself. It only gives you access to litigate it (litigation in NLD: Geschil). There is no patent police, nobody looks out for your patent. You have to go to court to prevent someone from using your patent.  
You have to identify infringement and there have to be barriers to infringement. A patent is not useful without. Except from attracting some investors. Usually patents are only interesting when there's lots of money at stake (huge investments to make it, business model will fail if you don't have a patent (you're not sure if you get your huge investment back), etc).   
So this patent system can be misused by trolls, NPEs (non practicing entities, they don't do anything but exhausting you by litigating), submarines (you make a patent but don't talk about it until somebody makes money and only then you litigate). So there are many bitter inventors who lost because big companies have more money and don't care about long days in court.  

Cost:  
provisional: $100  
Filing: $1k
Doing it for 1 country: $10k.
Doing it in multiple countries: $100k

A copyright apply to technical content. You can copyright a design, software, circuits, PCB layouts (mask works), etc. They include the rights to reproduce, modify, distribute, perform, display.  
You get the copyright simply by creation. Add the copyright note to your creation. You can register it but that's not needed. So you copyright the embodiment of your creative work. It means somebody can't use your creative designs. But they can do a clean room reinvention. Take the specification, put people in a room that haven't seen anything that is copyrighted and let them make it purely based on the specification.  

Once you have the copyright, you get to decide how you provide a license for other people to use it.  
If it's open-source it doesn't mean that it's free. See Red Hat.  
There are lots of licenses. Usually they are many pages long.  

This is the "fab-license", created years ago by Neil with help of MIT lawyers:  
// This work may be reproduced, modified, distributed, performed, and 
// displayed for any purpose, but must acknowledge the mods
// project. Copyright is retained and must be preserved. The work is 
// provided as is; no warranty is provided, and users accept all 
// liability.
(taken from the mods project as shown by Neil).  

Copyright and AI is a complete trainwreck. Almost all AIs are infringing copyrights. They are trained on copyrighted material. It's a big mess.  

OSHWA is an association of open hardware developers.

Trademarks are not copyrights or patents. It's the (tm) symbol. You register it and nobody is allowed to use it. Fablab is not trademarked. Because you always have to add the (tm) and when somebody doesn't use it correctly, you'll have to litigate. A conscious decision is to not trademark it.  

So patents are usually for Fablab inventions not very useful. till you want to get money from it.  
Selling your invention is usually the worst way to get money from it.  
Sell the actual product is better. But a lot of work.  
You can also think about selling it as:  
kit (Prusa),  
sell consumables (Gilette),  
licenses (ARM, there are some patents they have but majority is copyright on the design and code so other companies can use it and don't have to do themselves from scratch),  
Advertisements (google)  
Platforms (itunes)  
Infrastructure (AWS)  
services (Fabfoundation where the services of the fabfoundation are sold).  

Selling the services is considered one of the better ways do gain money from your work at a fablab (or running a fablab). Many successful business models nowadays don't sell the product, but the service to get benefits of the product.  
These services include:  
 operation  
 consumption  
customization  
 education  
 entertainment  
 impact  
 research  

Non-profit doesn't mean no money. It means that you can cover the cost and not more than that. But still have lots of cost.  

