#include <Adafruit_NeoPixel.h>
#define LEDPIN 9
#define STARTLEDDELAY 100
#define SENSORPIN 4
#define LOOPDELAY 10

#define NEOPIXELPIN 14
#define NUMPIXELS 1
Adafruit_NeoPixel pixels(NUMPIXELS, NEOPIXELPIN, NEO_GRB + NEO_KHZ800);

void setup() {
  pinMode(LEDPIN, OUTPUT); // set LED pin to output
  digitalWrite(LEDPIN, HIGH); // turn LED on
  delay(STARTLEDDELAY); // wait
//  Serial.begin(9600); // enable serial communication
  pinMode(SENSORPIN, INPUT); // set sensor pin to input.
  pixels.begin();
  pixels.clear();
  pixels.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)

  digitalWrite(LEDPIN, LOW); // turn LED off
//  Serial.println("Starting the measurement");
}

void loop() {
  int ADCMeasurement;
  ADCMeasurement = analogRead(SENSORPIN);
//  Serial.println((String)"Measurement value = " + ADCMeasurement);
  int pixelColor = map(ADCMeasurement, 900, 1023, 0, 65535); // map(value, fromLow, fromHigh, toLow, toHigh)
  int color = pixels.gamma32(pixels.ColorHSV(pixelColor)); // hue -> RGB
  pixels.setPixelColor(0, color); // Set pixel 'c' to value 'color'
  pixels.show(); // Update strip with new contents
  delay(LOOPDELAY); // slow down the loop to give time for proper measurements
}
