#include <Adafruit_NeoPixel.h>
#define NEOPIXELPIN 5
#define NUMPIXELS 1
#define LEDPIN 9
#define BUTTONPIN 8
Adafruit_NeoPixel pixels(NUMPIXELS, NEOPIXELPIN, NEO_GRB + NEO_KHZ800);
#define STARTLEDDELAY 100
#define BUTTONDELAY 10

void setup() {
  pinMode(LEDPIN, OUTPUT); // set LED pin to output
  pixels.begin();
  digitalWrite(LEDPIN, HIGH); // turn LED on
  delay(STARTLEDDELAY); // wait
  pixels.clear();
  pixels.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)
//  Serial.begin(9600); // enable serial communication
  pinMode(BUTTONPIN, INPUT_PULLUP); // set button pin to input. Use pullup because the button is connected to GND.

  digitalWrite(LEDPIN, LOW); // turn LED off
  delay(STARTLEDDELAY); // wait
}

void loop() {
  int R, G, B; // initialize integers to hold color information
  if (debouncedButton()) {
    randomColor(R, G, B); // call randomizer function
    // Serial.println((String)"The new color is " + R + ", " + G + ", " + " B"); // print the color to the serial monitor, using (String) to typecast
    pixels.setPixelColor(0, R, G, B); // set the pixel colors
    pixels.show(); // Update Neopixel with new content

  };
  delay(BUTTONDELAY);
}

void randomColor(int & R, int & G, int & B) { // a function that randomly set a value to R, G and B. It passes these variables by reference (&) so changes affect the original variable.
  R = random(0,255);
  G = random(0,255);
  B = random(0,255);
}

bool debouncedButton() { // debounce function for 1 button. See https://www.e-tinkers.com/2021/05/the-simplest-button-debounce-solution/
  static uint16_t state = 0;
  state = (state<<1) | digitalRead(BUTTONPIN) | 0xfe00;
  return (state == 0xff00);
}