#include <Adafruit_NeoPixel.h>
#define PIN 5
#define NUMPIXELS 1
#define LED 9
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
#define STARTLEDDELAY 100
#define NEOPIXELDELAY 20

void setup() {
  pinMode(LED, OUTPUT);
  digitalWrite(LED, LOW); // turn LED off
  pixels.begin();
  pixels.clear();
  pixels.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)
}

void loop() {
  for(long firstPixelHue = 0; firstPixelHue < 65536; firstPixelHue += 256) {
    int color = pixels.gamma32(pixels.ColorHSV(firstPixelHue)); // hue -> RGB
    pixels.setPixelColor(0, color); // Set pixel 'c' to value 'color'
    pixels.show(); // Update strip with new contents
    delay(NEOPIXELDELAY);  // Pause for a moment
  }
}

// // rainbow code above only works if config.h in Tools menu is enabled because otherwise it doesn't fit the memory. But total chaos below works with config.h disabled too :-)
// #include <Adafruit_NeoPixel.h>
// #define PIN 5
// #define NUMPIXELS 1
// #define LED 9
// Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
// #define STARTLEDDELAY 100
// #define NEOPIXELDELAY 50

// void setup() {
//   pinMode(LED, OUTPUT);
//   digitalWrite(LED, LOW); // turn LED off
//   pixels.begin();
//   pixels.clear();
//   pixels.setBrightness(10); // Set BRIGHTNESS to about 1/5 (max = 255)
// }

// void loop() {
//   int R, G, B;
//   R = random(0,255);
//   G = random(0,255);
//   B = random(0,255);
//   pixels.setPixelColor(0, R, G, B);
//   pixels.show(); // Update strip with new contents
//   delay(NEOPIXELDELAY);  // Pause for a moment
// }
