#define LEDPIN 9
#define BUTTONPIN 8
#define STARTLEDDELAY 100
#define BUTTONDELAY 10

void setup() {
  pinMode(LEDPIN, OUTPUT); // set LED pin to output
  digitalWrite(LEDPIN, HIGH); // turn LED on
  delay(STARTLEDDELAY); // wait
  Serial.begin(9600); // enable serial communication
  pinMode(BUTTONPIN, INPUT_PULLUP); // set button pin to input. Use pullup because the button is connected to GND.

  digitalWrite(LEDPIN, LOW); // turn LED off
  delay(STARTLEDDELAY); // wait
}

void loop() {
  static bool ledState;
  if (debouncedButton()) { // only do this when button is pressed
    static int x; // a place to store the amount of button presses. static because it needs to keep its value when it loops.
    ledState = !ledState;
    Serial.println((String)"The button is pressed " + x + " times!"); // print the color to the serial monitor, using (String) to typecast
    x++;
  }
  digitalWrite(LEDPIN, ledState); // turn LED on or off
  delay(BUTTONDELAY);
}

bool debouncedButton() { // debounce function for 1 button. See https://www.e-tinkers.com/2021/05/the-simplest-button-debounce-solution/
  static uint16_t state = 0;
  state = (state<<1) | digitalRead(BUTTONPIN) | 0xfe00;
  return (state == 0xff00);
}