#include <SERCOM.h>
#include <wiring_private.h>

#define MY_SERCOM sercom0

static const uint8_t MY_MISO = 2;	// sercom1 PAD[0]
static const uint8_t MY_MOSI = 14; // sercom0 PAD[0]
static const uint8_t MY_SCK = 15; // sercom0 PAD[1]
static const uint8_t MY_SS = 9;

static const EPioType MY_MOSI_PIOTYPE = PIO_SERCOM;
static const EPioType MY_MISO_PIOTYPE = PIO_SERCOM;
static const EPioType MY_SCK_PIOTYPE = PIO_SERCOM;

static const SercomSpiTXPad MY_TXPAD = SPI_PAD_0_SCK_1; // PAD[0] is output is MOSI
static const SercomRXPad MY_RXPAD = SERCOM_RX_PAD_0; 	// PAD[0] is input is MISO


void setup()
{
	pinPeripheral( MY_MISO, MY_MISO_PIOTYPE );
	pinPeripheral( MY_MOSI, MY_MOSI_PIOTYPE );
	pinPeripheral( MY_SCK, MY_SCK_PIOTYPE );
	// pinMode(MY_MOSI, OUTPUT);
	// pinMode(MY_MISO, OUTPUT);
	// pinMode(MY_SCK, OUTPUT);
	pinMode(MY_SS, OUTPUT);
	digitalWrite( MY_SS, HIGH ); // HIGH means not selected
  
}
void loop()
{
	// Start up SPI
	MY_SERCOM.resetSPI();
  	MY_SERCOM.initSPI(MY_TXPAD, MY_RXPAD, SPI_CHAR_SIZE_8_BITS, MSB_FIRST);
	MY_SERCOM.initSPIClock(SERCOM_SPI_MODE_3, 1000000);
	//	_description.sercom->initSPIClock(SERCOM_SPI_MODE_0, 4000000);
	MY_SERCOM.enableSPI();

	// Wake up secondary
	digitalWrite ( MY_SS, LOW );
	delay(10);
	// Exchange data
  const char *MASTER_MESSAGE = "|-- Hello world! --|";
  const int MASTER_MESSAGE_LEN = 20;

	for ( uint16_t count = 0; count < MASTER_MESSAGE_LEN; count++ )
	{
		MY_SERCOM.transferDataSPI(MASTER_MESSAGE[count]);
		delay(1);
	}
	
	// Turn off SPI
	MY_SERCOM.resetSPI();
	
	// Tell secondary to rest
	digitalWrite(MY_SS, HIGH);

  delay(500);
  for (uint8_t i = 0; i < 10; i++){
	digitalWrite(MY_SS, LOW);
	// digitalWrite(MY_MOSI, LOW);
	// digitalWrite(MY_SCK, HIGH);
	// digitalWrite(MY_MISO, LOW);
	delay(50);
	digitalWrite(MY_SS, HIGH);
	// digitalWrite(MY_MOSI, HIGH);
	// digitalWrite(MY_SCK, LOW);
	// digitalWrite(MY_MISO, HIGH);
	delay(50);
  }
 	 delay(500);

}