/*
blinkhelloworld-samd21.ino
Leo Kuipers april 2024

inital test of samd21j18a microcontroller.

actual pin numbering of samd21 chips (e.g. portA21 or portB30) is in no way related to arduino pin numbering used in sketches.
To get to the arduino pin number, see https://github.com/qbolsee/ArduinoCore-fab-sam/blob/master/variants/Generic_xx1J/variant.cpp
In this file you'll find the PinDescription table of this microcontroller.
Look for the actual pin number you want to program and check the commented line above it to find the arduino numbering. e.g. 
PORTA, 21 on line 130 -> // 12..Digital functions (line 120) -> meaning actual pin number PA21 = arduino number 21 
PORTB, 30 on line 166 -> // 43..46 - SPI Header (line 165) -> meaning actual pin number PB30 = arduino number 43

This work may be reproduced, modified, distributed,
performed, and displayed for any purpose, but must
acknowledge this project. Copyright is retained and
must be preserved. The work is provided as is; no
warranty is provided, and users accept all liability.  
*/

int counter;
bool led;
const int PB30 = 43; // actual pin number PB30 = arduino pin number 43 
const int PB31 = 46; // actual pin number PB31 = arduino pin number 46
void setup() {
  pinMode(PB30, OUTPUT);
  pinMode(PB31, OUTPUT);
  Serial.begin(115200); // start serial communication
//  while (!Serial); // wait for serial port to open before continuing. otherwise the first serial.prints will not be shown in serial monitor. if serial monitor is not opened, the program will not continue.
}

void loop() {
  Serial.print("Hello World! The counter is " );
  Serial.println(counter);
  counter++;
  digitalWrite(PB30, led);
  digitalWrite(PB31, !led);
  led = !led;
  delay(1000);
}