
#include <SERCOM.h>
#include <wiring_private.h>

#define MY_SERCOM sercom3
#define PIN_MISO MISO
#define PIN_SCK SCK
#define PIN_MOSI MOSI
#define PIN_DC MISO 
#define TFT_BL SS 

static const uint8_t MY_MISO = PIN_MISO;	
static const uint8_t MY_MOSI = PIN_MOSI; 
static const uint8_t MY_SCK = PIN_SCK; 

static const EPioType MY_MOSI_PIOTYPE = PIO_SERCOM;
static const EPioType MY_MISO_PIOTYPE = PIO_SERCOM;
static const EPioType MY_SCK_PIOTYPE = PIO_SERCOM;

static const SercomSpiTXPad MY_TXPAD = SPI_PAD_2_SCK_3; 
static const SercomRXPad MY_RXPAD = SERCOM_RX_PAD_0; 

void setup()
{
	pinPeripheral( MY_MISO, MY_MISO_PIOTYPE );
	pinPeripheral( MY_MOSI, MY_MOSI_PIOTYPE );
	pinPeripheral( MY_SCK, MY_SCK_PIOTYPE );
	pinMode(PIN_DC, OUTPUT);
	digitalWrite( TFT_BL, HIGH ); 
}
void loop()
{
	// Start up SPI
	MY_SERCOM.resetSPI();
  	MY_SERCOM.initSPI(MY_TXPAD, MY_RXPAD, SPI_CHAR_SIZE_8_BITS, MSB_FIRST);
	// MY_SERCOM.initSPIClock(SERCOM_SPI_MODE_3, 1000000);
	MY_SERCOM.initSPIClock(SERCOM_SPI_MODE_3, 20000000);


	//	_description.sercom->initSPIClock(SERCOM_SPI_MODE_0, 4000000);
	MY_SERCOM.enableSPI();

	// Wake up secondary
	digitalWrite ( TFT_BL, LOW );
	delay(10);
	// Exchange data
  const char *MASTER_MESSAGE = "|-- Hello world! --|";
  const int MASTER_MESSAGE_LEN = 20;

	for ( uint16_t count = 0; count < MASTER_MESSAGE_LEN; count++ )
	{
		MY_SERCOM.transferDataSPI(MASTER_MESSAGE[count]);
		delay(1);
	}
	
	// Turn off SPI
	MY_SERCOM.resetSPI();
	
	// Tell secondary to rest
	digitalWrite(TFT_BL, HIGH);

  delay(500);
  for (uint8_t i = 0; i < 10; i++){
	digitalWrite(TFT_BL, LOW);
	// digitalWrite(MY_MOSI, LOW);
	// digitalWrite(MY_SCK, HIGH);
	// digitalWrite(MY_MISO, LOW);
	delay(50);
	digitalWrite(TFT_BL, HIGH);
	// digitalWrite(MY_MOSI, HIGH);
	// digitalWrite(MY_SCK, LOW);
	// digitalWrite(MY_MISO, HIGH);
	delay(50);
  }
 	 delay(500);

}