/*
** This work may be reproduced, modified, distributed, performed, and 
** displayed for any non-commercial, non-profit purpose, but must acknowledge 
** the developer and the Marimbatron project. 
** Copyright is retained and must be preserved. The work is 
** provided as is; no warranty is provided, and users accept all liability.
** 
** Copyright 2024 Leo Kuipers.
*/

#include "Arduino.h"
#include "Sensor.h"
Sensor::Sensor(/* args */) { // constructor definition. The two colons are called a scope resolution operator.
    _hit = false;
    _velocity = 4095;
}
void Sensor::setThreshold(uint32_t newThreshold){
    _threshold = newThreshold;
}
uint32_t Sensor::getThreshold(){
    return _threshold;
}
void Sensor::setScanTime(uint32_t newScanTime){
    _scanTime = newScanTime;
}
uint32_t Sensor::getScanTime(){
    return _scanTime;
}
void Sensor::setMaskTime(uint32_t newMaskTime){
    _maskTime = newMaskTime;
}
uint32_t Sensor::getMaskTime(){
    return _maskTime;
}
void Sensor::setLastADCTime(unsigned long newLastADCTime) {
    _lastADCTime = newLastADCTime;
}
unsigned long Sensor::getLastADCTime() {
    return _lastADCTime;
}
void Sensor::setVelocity(uint32_t newVelocity){
    _velocity = newVelocity;
}
uint32_t Sensor::getVelocity(){
    return _velocity;
}
void Sensor::setHit(bool newHit){
    _hit = newHit;
}
bool Sensor::getHit(){
    return _hit;
}
